"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
function control_changes(st) {
    function identify_change(key) {
        var val = st.get(key);
        var val_backup = st.backup.get(key);
        if (Array.isArray(val) && Array.isArray(val_backup) && val.length !== val_backup.length) {
            return true;
        }
        else if (Array.isArray(val) || Array.isArray(val_backup)) {
            return JSON.stringify(val) !== JSON.stringify(val_backup);
        }
        else if (typeof val === 'object' || typeof val_backup === 'object') {
            return JSON.stringify(val) !== JSON.stringify(val_backup);
        }
        else if (utils_1.isSttore(val)) {
            return val.change();
        }
        return val !== val_backup;
    }
    function change(key) {
        if (key !== undefined) {
            if (!st.has(key))
                return false;
            return identify_change(key);
        }
        var has_change = false;
        for (var key_1 in st.list()) {
            has_change = identify_change(key_1);
            if (has_change)
                break;
        }
        return has_change;
    }
    function changes() {
        var changes = {};
        var list = st.list();
        for (var key in list) {
            var value = list[key];
            if (identify_change(key)) {
                changes[key] = value;
            }
        }
        return changes;
    }
    return {
        change: change,
        changes: changes
    };
}
exports.default = control_changes;
